#!/usr/bin/env python
# -*- coding: Latin-1 -*-

"""
Ce script est la partie principale du pluing WebCollection

Auteur: Jean-Marc Mongrelet

Licence: GPL
"""

import os
import Commun
impr = []
impr.append(['Collection',''])
impr.append(['urllib',''])
impr.append(['time',''])
impr.append(['calendar',''])
impr.append(['user',''])
impr.append(['tempfile',''])
impr.append(['xml','from xml.dom import minidom'])
# impr.append(['Multimedia',''])
exec Commun.import2



PARAMETRE = {}		# Stocke les parametres passés en url
INT_ACCDATE = 0		# Valeur de l'"accessdate" de l'inputbox en integer


def inputParramettre(parr):
	# parr = :
	# 'accdate'	date/time de filtrage
	# 'dir'		Repaetoire sélectionné
	#  nf'		nom du fichier à mettre en playlist
	# 'ss'		nom du fichier à envoiller dans xmms (pour le casque)
	# 'cs'		mémorisation de ss dans le but le le mettre en playlist
	global PARAMETRE
	PARAMETRE = {}
	a1 = parr.split("?")
	if len(a1) == 2 :
		a2 = a1[1].split("&")
		for i in a2 :
			a3 = i.split("=")
			if len(a3) == 2 :
				PARAMETRE.update( \
				{a3[0]:urllib.unquote_plus(a3[1])})




class PostRQ:

    def __init__(self):
	pass


    def get(self):
    	if PARAMETRE.has_key('nf') or PARAMETRE.has_key('ss') :
		return self.get_B()
	else :
		return self.get_A()


    def get_B(self):
	global PARAMETRE
    	PARAMETRE = supp_key_in_dico(PARAMETRE, 'nf')
	PARAMETRE = supp_key_in_dico(PARAMETRE, 'ss')
	url = '/'
	liste = PARAMETRE.keys()
	while liste :
		param = liste.pop()
		if PARAMETRE.has_key(param) :
			if url == '/' :
				url = '/?%s=%s'%(param, urllib.quote_plus(PARAMETRE[param]) )
			else :
				url = '%s&%s=%s'%(url, param, urllib.quote_plus(PARAMETRE[param]) )
	return """ <html>\n
                    <head>
                    <meta http-equiv="Refresh" content="0;url=%s">
                    <meta http-equiv="content-type" content="text/html; charset=UTF-8">
                    <style>
                    body {
                        font-size:10pt;
                        margin-left:5%%;
                        margin-right:5%%;
                        background-color: #9cb2cd;
                        color: white;
                          }
                    </style>
                    </head> 
                    <title>AmaroK collection</title>
	            <body>
	            </body>
 </html>
              """%(url)



    def get_A(self):
	Collection.LEGENDE = """


	<u><b>Légende:</u></b><BR>
	<FONT color="#FF0000">En Rouge:</FONT> Les fichiers qui dépassent la date de début de l'animation.<BR>
	<FONT color="#7FFF7F">En Vert:</FONT> Tous les fichiers, ou seulement ceux qui sont anterieurs à la date de début de l'animation.<BR>
	<S>Barré:</S> Les fichiers qui se trouvent dans la Playlist.<BR>
	* La date de début de l'animation correspond au moment à partir duquel on veut savoir ce qui à été joué (en rouge) et ce qui n'a pas été joué (en vert).<BR>
	Et pour cela elle est comparée à la date d'acces (colonnes "Accès")

"""
	self.fields = ("Fichier", "Artiste", "Titre", "Durée")
	Collection.FIELDS = self.fields + ("Accès", "Note")
	self.prugeParametre()
	ordre = self.defOrdre()
	self.init_statistics()
        self.playlist()
	Collection.DIRCOMBOBOX = self.inputBoxTime() \
				+ self.casque2playlist() \
				+ self.selctedir() \
				+ self.selcteordre()

	#ordre = " ORDER BY 2, 3 ,1"	
	if PARAMETRE.has_key('dir') :
		if PARAMETRE['dir'] == 'All (Tous les fichiers)' :
			requette = os.popen('dcop amarok collection query "select devices.lastmountpoint,url,artist.name,title,length from tags,artist,devices WHERE artist.id=tags.artist AND devices.id=tags.deviceid%s"'%(ordre)).readlines()
		else :
			device, dir = \
				PARAMETRE['dir'].replace("'","''").split('/./')
			if device == '' :	device = '/'
       			requette = os.popen('dcop amarok collection query "select lastmountpoint,url,artist.name,title,length from tags,directories,artist,devices WHERE devices.lastmountpoint=\'%s\' AND tags.deviceid=devices.id AND tags.dir=directories.dir AND directories.dir=\'./%s\' AND artist.id=tags.artist%s"'%(device, dir, ordre)).readlines()
		
	else :
		requette = []
	if requette == ['\n']:
		requette = []
	requette.reverse()
	Collection.DOC_COLLECTION = []
	if Commun.config_txt('ss') == 'on' :
		lien = self.lien1
	else :
		lien = self.lien2
	while requette:
		device = requette.pop().replace('\n','')
		fichier = os.path.join(device, requette.pop().replace('\n','') \
							).replace('/./','/')
		accdate, note = self.stat.get(fichier, ['0', ''])
		
		Collection.DOC_COLLECTION = Collection.DOC_COLLECTION \
		+ [ lien(fichier, os.path.basename(fichier), accdate) ] \
		+ [ requette.pop() ]
		Collection.DOC_COLLECTION = Collection.DOC_COLLECTION \
		+ [ requette.pop() ]
		Collection.DOC_COLLECTION = Collection.DOC_COLLECTION \
		+ [time.strftime("%H:%M:%S", time.gmtime(int(requette.pop())))]
		if accdate <> '0' :
			valeur = time.strftime("%H:%M:%S %d/%m/%y", time.localtime(int(accdate)))
		else :
			valeur = '-'
		
		Collection.DOC_COLLECTION = Collection.DOC_COLLECTION \
		+ [ valeur ]
		Collection.DOC_COLLECTION = Collection.DOC_COLLECTION \
		+ [ note ]
	if Collection.DOC_COLLECTION == []:
		Collection.DOC_COLLECTION = ['\n']
       	collect = Collection.Collection()
	return collect.toHtml()

    def prugeParametre(self):
	global PARAMETRE
	if PARAMETRE.get('dir', '') in [ '', '.' ] :
		PARAMETRE = supp_key_in_dico(PARAMETRE, 'dir')
	if PARAMETRE.get('accdate', '') == '' :
		PARAMETRE = supp_key_in_dico(PARAMETRE, 'accdate')
	for num in range(len(self.fields)) :
		if PARAMETRE.get(str(num), '') == '' :
			PARAMETRE = supp_key_in_dico(PARAMETRE, str(num))


	
    def defOrdre(self):
	tabOrdre = []
	for num in range(len(self.fields)) :
		tabOrdre.append(PARAMETRE.get(str(num), ''))
	if tabOrdre[0] == '' :
		self.purgeParaOrdre(0)
		return ''
	else :
		ordre = " ORDER BY " + tabOrdre[0]
	for num in range(len(self.fields))[1:] :
		if tabOrdre[num] == '' :
			self.purgeParaOrdre(num)
			return ordre
		else :
			if tabOrdre[num] in tabOrdre[:num] :
				self.purgeParaOrdre(num)
				return ordre
			else :
				ordre = ordre + ', ' + tabOrdre[num]
	return ordre

    def purgeParaOrdre(self, num):
	global PARAMETRE
	for num in range(len(self.fields))[num:] :
		PARAMETRE = supp_key_in_dico(PARAMETRE, str(num))


    def init_statistics(self):
	statistics = os.popen('dcop amarok collection query "select lastmountpoint,url,accessdate,rating from statistics,devices WHERE devices.id=statistics.deviceid ORDER BY 1, 2"').readlines()
	if statistics == ['\n'] :
		statistics = []
	statistics.reverse()
	self.stat = {}
	while statistics :
		key = statistics.pop().replace('\n','')
		key = os.path.join(key, statistics.pop().replace('\n','') \
							 ).replace('/./','/')
		accessdte = statistics.pop().replace('\n','')
		note = '%s /10'%(statistics.pop().replace('\n',''))
		self.stat.update({key:[accessdte, note]})
	
	
	
    def lien1(self, url, texte, datezz):
	plist = '%s'
	if url in self.playlist :
		plist = '<S>%s</S>'
	ck, t = accdate_ck_int()
	style = 'normal'
	if ck and int(datezz) > t :
		style = 'playold'
	urlqplus = urllib.quote_plus(url)
	######## version avec xmms ##############
	return plist%('<a class="ss" href="/?ss=%s%s">ss</a> <a class="%s" href="/?nf=%s%s">%s</a>'%( \
		urlqplus, \
		self.lienHidden(rmtab(PARAMETRE.keys(), 'ss')), \
		style, \
		urlqplus, \
		self.lienHidden(rmtab(PARAMETRE.keys(), 'nf')), \
		texte))


    def lien2(self, url, texte, datezz):
	plist = '%s'
	if url in self.playlist :
		plist = '<S>%s</S>'
	ck, t = accdate_ck_int()
	style = 'normal'
	if ck and int(datezz) > t :
		style = 'playold'
	urlqplus = urllib.quote_plus(url)
	######## version sans xmms ##############
       	return plist%('<a class="%s" href="/?nf=%s%s">%s</a>'%( \
        	style, \
        	urllib.quote_plus(url), \
        	self.lienHidden(rmtab(PARAMETRE.keys(), 'nf')), \
        	texte))



    def playlist(self):
	filetemps = tempfile.mktemp('.2playlistXml')
	os.system("dcop amarok playlist saveCurrentPlaylist > %s"%(filetemps))
	f = open(filetemps, "r")
	playlistfile = f.readline().replace('\n','')
	f.close()
	os.remove(filetemps)
	
	xml = minidom.parse(playlistfile)
	rechdb=' url="file:'
	self.playlist = []
	for item in xml.childNodes[0].getElementsByTagName("item") :
		self.playlist = self.playlist \
		+ [ '%s'%(urllib.unquote_plus(item.getAttribute("url")[7:].encode("latin1", "replace"))) ]



    def selctedir(self):
	dirbrut = os.popen('dcop amarok collection query \'select DISTINCT lastmountpoint,dir from tags,devices WHERE devices.id=tags.deviceid ORDER BY 1, 2\'').readlines()
	listdir = [{'url': '.', 'txt': ''}, \
		   {'url': 'All (Tous les fichiers)', \
			'txt': 'All (Tous les fichiers)'}]
	dirbrut.reverse()
	while dirbrut:
		d = dirbrut.pop().replace("\n",'')
		if d <> '/' :
			d = d + '/'
		d = d + dirbrut.pop().replace("\n",'')
		d2 = pathuser(d.replace('/./','/'))
		d3 = d2[-150:]
		if d3 <> d2 :
			d3 = '...%s'%(d3)
		listdir.append({'url':d,'txt':d3})
	return """
	
	Choisir votre répertoire : <BR>
	%s"""%(self.comboboxAuto(listdir, 'dir'))

    def casque2playlist(self):
	if not PARAMETRE.has_key('cs') :
		return ''
	urlfile = PARAMETRE['cs']
	datezz = self.stat.get(urlfile, ['0', ''])[0] 
        plist = '%s %s <BR><BR>'
        if urlfile in self.playlist :
                plist = '%s <S>%s</S> <BR><BR>'
        ck, t = accdate_ck_int()
        style = 'normal'
        if ck and int(datezz) > t :
                style = 'playold'
        return plist%('Mettre en playlist le dernier fichier joué au casque :',\
			'<a class="%s" href="/?nf=%s%s">%s</a>'%( \
        style, \
	urllib.quote_plus(urlfile), \
        self.lienHidden(rmtab(PARAMETRE.keys(), 'nf')), \
        os.path.basename(urlfile) ) )
 
    def selcteordre(self):
	webhtml = """
		Choisir le classement : 
		<FORM action="/" method="get">%s
		<INPUT type="submit" value="Ok">
		</FORM>

"""
	num = 2
	list =[{'url':'','txt':''}]
	for fi in self.fields :
		list.append({'url':str(num),'txt':fi})
		num=num+1
	comboxs = ''
	parametrekeys = PARAMETRE.keys()
	for key in range(len(self.fields)) :
		comboxs = comboxs + self.comboboxOrdre(list, str(key))
		parametrekeys = rmtab(parametrekeys, str(key))
	return webhtml%('%s%s'%(comboxs, self.inputHidden(parametrekeys)))

    def comboboxOrdre(self, liste, name):
	webhtml ="""
		<SELECT name="%s">%s
		</SELECT>"""
	return webhtml%(name, self.combobox(liste, name))

    def comboboxAuto(self, liste, name):
	webhtml = """<FORM action="/" method="get" id="formulaire-%s">
		<SELECT name="%s" onchange="document.forms['formulaire-%s'].submit();">"""%(name, name, name)
	return webhtml + self.combobox(liste, name) + """
		</SELECT>""" \
	+ self.inputHidden(rmtab(PARAMETRE.keys(), name)) + """
		</FORM>
		"""


    def combobox(self, liste, name):
	option = """
	<OPTION%s value="%s">
	%s</OPTION>"""
	webhtml = ''
	for donnees in liste :
		if PARAMETRE.has_key(name) \
		and donnees['url'] == PARAMETRE[name] :
			select = ' selected'
		else :
			select = ''
		webhtml = webhtml \
		+ option%(select, donnees['url'], donnees['txt'])
	return webhtml 


    def inputBoxTime(self):
	webhtml = """

		<BR><FORM action="/" method="get">
        	Choisir l'heure et la date de début de l'animation (* Voir légende en bas) 
		("hh:mm:ss JJ/MM/AA" ex: 15:30:00 16/09/07) 
        	<BR><INPUT name="accdate" value="%s" >
        	<INPUT type="submit" value="Ok" >%s</FORM>"""
	return webhtml%(PARAMETRE.get('accdate','ex: %s'%(time.strftime("%H:%M:%S %d/%m/%y", time.localtime()))), self.inputHidden(rmtab(PARAMETRE.keys(), 'accdate')))


    def inputHidden(self, liste):
	webhidem = """<INPUT type=hidden name="%s" value="%s" >
                      """
	webhid = ''
	while liste :
		param = liste.pop()
		if PARAMETRE.has_key(param) :
			webhid = webhid + webhidem%(param, \
			PARAMETRE[param])
	return webhid

    def lienHidden(self, liste):
	webhid = ''
        while liste :
                param = liste.pop()
                if PARAMETRE.has_key(param) :
			webhid = webhid + '&%s=%s'%(param, \
			urllib.quote_plus(PARAMETRE[param]))
        return webhid


def rmtab(tableau, key):
	if key in tableau :
		tableau.remove(key)
	return tableau
	

def inPlayerList():
	global PARAMETRE
	if PARAMETRE.has_key('nf') :
		#Multimedia.MULTIMEDIA.set_Baffle(PARAMETRE['nf'])
		os.popen('amarok -a "%s"'%(PARAMETRE['nf']), 'w', 0)
	if PARAMETRE.has_key('ss') :
		#Multimedia.MULTIMEDIA.set_Casque(PARAMETRE['ss'])
		os.popen('%s "%s" &'%(Commun.config_txt('xmms'),PARAMETRE['ss']), 'w', 0)
		PARAMETRE['cs'] = PARAMETRE['ss']	


def accdate_init():
	global PARAMETRE
	global INT_ACCDATE
	if not PARAMETRE.has_key('accdate') :
		return
	decalageHoraire = calendar.timegm(time.gmtime())- \
			  calendar.timegm(time.localtime())
	try:
		INT_ACCDATE = calendar.timegm(time.strptime(PARAMETRE['accdate'],"%H:%M:%S %d/%m/%y")) + decalageHoraire
	except :
		PARAMETRE = supp_key_in_dico(PARAMETRE, 'accdate')

def accdate_ck_int():
	global PARAMETRE
	if not PARAMETRE.has_key('accdate') :
		return 0, ''
	return -1, INT_ACCDATE




def supp_key_in_dico(dico, key):
	dic = {}
        for k in dico.keys() :
                if k <> key :
                        dic.update({k:dico[k]})
        return dic



def pathuser(path):
	if path[:len(user.home)] == user.home :
		return '~%s'%(path[len(user.home):])
	return path



